using System;
using System.Collections.Generic;
using System.Text;

using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace MyKarte.Database
{
    /// <summary>
    /// SQL Server NX
    /// </summary>
    public sealed class SqlServer : DbBase
    {
        // [JzXg
        private const string _localHost = "(local)\\SQLEXPRESS";

        // [UID(ftHg)
        private const string _defaultUserId = "sa";

        // pX[h(ftHg)
        private const string _defaultPassword = null;

        // zXg
        private string _host;

        // f[^x[X
        private string _dbName;

        // [UID
        private string _userId;

        // pX[h
        private string _password;

        // ڑv[
        private bool _pooling;

        #region vpeB
        /// <summary>
        /// [JzXg
        /// </summary>
        public static string LocalHost
        {
            get
            {
                return _localHost;
            }
        }

        /// <summary>
        /// [UID(ftHg)
        /// </summary>
        public static string DefaultUserId
        {
            get
            {
                return _defaultUserId;
            }
        }

        /// <summary>
        /// pX[h(ftHg)
        /// </summary>
        public static string DefaultPassword
        {
            get
            {
                return _defaultPassword;
            }
        }
        #endregion

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="host">zXg</param>
        /// <param name="dbName">f[^x[X</param>
        public SqlServer(string host, string dbName)
            : this(host, dbName, _defaultUserId, _defaultPassword, true)
        {
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="host">zXg</param>
        /// <param name="dbName">f[^x[X</param>
        /// <param name="pooling">ڑv[</param>
        public SqlServer(string host, string dbName, bool pooling)
            : this(host, dbName, _defaultUserId, _defaultPassword, pooling)
        {
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="host">zXg</param>
        /// <param name="dbName">f[^x[X</param>
        /// <param name="userId">[UID</param>
        /// <param name="password">pX[h</param>
        public SqlServer(string host, string dbName, string userId, string password)
            : this(host, dbName, userId, password, true)
        {
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="host">zXg</param>
        /// <param name="dbName">f[^x[X</param>
        /// <param name="userId">[UID</param>
        /// <param name="password">pX[h</param>
        /// <param name="pooling">ڑv[</param>
        public SqlServer(string host, string dbName, string userId, string password, bool pooling)
        {
            _host = host;
            _dbName = dbName;

            _userId = userId;
            _password = password;

            _pooling = pooling;

            this.Connection = CreateConnection();
            this.Connection.ConnectionString = GetConnectionString();
        }

        /// <summary>
        /// DbProviderFactory擾B
        /// </summary>
        /// <returns>DbProviderFactory</returns>
        protected override DbProviderFactory GetFactory()
        {
            return DbProviderFactories.GetFactory("System.Data.SqlClient");
        }

        /// <summary>
        /// ڑ擾B
        /// </summary>
        /// <returns>ڑ</returns>
        protected override string GetConnectionString()
        {
            SqlConnectionStringBuilder builder = new SqlConnectionStringBuilder();

            builder.DataSource = _host;
            builder.InitialCatalog = _dbName;

            // SQL ServerF
            builder.UserID = _userId;
            builder.Password = _password;

            // ڑv[
            builder.Pooling = _pooling;

            return builder.ConnectionString;
        }

        /// <summary>
        /// e[uꗗ擾B
        /// </summary>
        /// <returns>e[uꗗ</returns>
        public override string[] GetTables()
        {
            List<string> tables = new List<string>();

            StringBuilder sb = new StringBuilder();

            sb.Append("SELECT o.name");
            sb.Append("  FROM sysobjects o INNER JOIN sysindexes i ON o.id = i.id");
            sb.Append(" WHERE o.xtype = 'U'");
            sb.Append("   AND i.indid < 2");
            sb.Append(" ORDER BY o.name");

            DataTable dt = GetDataTable(sb.ToString());

            foreach (DataRow dr in dt.Rows)
            {
                tables.Add(Convert.ToString(dr["name"]));
            }

            return tables.ToArray();
        }
    }
}
